
///////////////////////////////////////////////////////////////////////////////
//
//	areas.h
//

#ifndef _AREAS_
#define _AREAS_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "base.h"
#include "window.h"


class ProjectManager;



struct AreaDataEx{
	WORD pos_x;
	WORD pos_y;
	WORD level_num;
	BYTE icon;
	BYTE type;
	struct Text{
		BYTE length;
		BYTE param;
		BYTE string[256];
	}text;
	struct Road{
		bool bValid;
		bool bParam;
		WORD area_num;
		WORD road_num;
	}road_left, road_right, road_up, road_down;
	bool bValid;
public:
	SADRS load(const ProjectManager *project, BANK bank, SADRS adrs);
	SADRS store(ProjectManager *project, BANK bank, SADRS adrs) const;
	SADRS get_end(const ProjectManager *project, BANK bank, SADRS adrs) const;
};



class AreasManager : public RomData_Base, public MyDialog{

	// rominfo.ini瓾f[^
private:
	int area_count;				// GA̐
	char (*area_name)[256];		// GA
	LADRS pAreaInfoAdrs;		// GAAhX(1oCgp[^+2oCgAhX)
	SADRS pAreaAvailableBegin;
	SADRS pAreaAvailableEnd;


private:
	ProjectManager *project;
	bool unable_edit_change;

private:
	LPCSTR get_template() const{ return "WORLD_COMPOSITION"; }
	BOOL Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
	void init();
	void apply();

public:
	AreasManager(ProjectManager *_project);
	~AreasManager();

	BOOL create();
	BOOL command(WPARAM wParam, LPARAM lParam);
	BOOL translate_dialog_message(MSG *msg);
	void set_state(BOOL bEnabled);
	void world_change(int index);
	void area_change(int index);

};




///////////////////////////////////////////////////////////////////////////////

#endif // _AREAS_


