
///////////////////////////////////////////////////////////////////////////////
//
//	char.cpp
//

#include "char.h"
#include "project.h"
#include "id.h"
#include <string.h>


CharacterManager::CharacterManager(ProjectManager *_project) : project(_project){
	char s[16];
	for (int i=0; i<256; i++){
		sprintf_s(s, sizeof s, "%02X", i);
		GetPrivateProfileString("Characters", s, "??", shift_jis[i], sizeof(shift_jis[i]), RomInfoFileName);
	}
}

CharacterManager::~CharacterManager(){
}


int CharacterManager::to_shift_jis(char *buf, BYTE src[], size_t src_size){
	size_t n=0;
	for (size_t i=0; i<src_size; i++){
		buf[n++] = shift_jis[src[i]][0];
		buf[n++] = shift_jis[src[i]][1];
	}
	buf[n] = '\0';
	return n;
}

int CharacterManager::from_shift_jis(const char *src, BYTE buf[], size_t buf_size){
	int n=0;
	int k=0;
	while (src[n] != '\0'){
		char c0 = src[n++];
		char c1 = src[n++];
		int code = -1;
		for (int i=0; i<256; i++){
			if (shift_jis[i][0] == c0 && shift_jis[i][1] == c1) code = i;
		}
		if (code == -1){
			// sȕ
			return -1;
		}
		buf[k++] = (BYTE)code;
	}
	return k;
}





