
////////////////////////////////////////////////////////////
//
//  map_compresser.cpp
//

#include <map>
#include <windows.h>
#include "map_compresser.h"

using namespace std;


static void init_header(CMPHeader *header, const unsigned char *buf_src, unsigned int src_size);


int CompressData(
	unsigned char *buf,
	unsigned int buf_size,
	const unsigned char *buf_src,
	unsigned int src_size
	)
{

	CMPHeader header;

	// wb_쐬
	init_header(&header, buf_src, src_size);

	// wb_Rs[
	buf[0] = 0;
	*(CMPHeader*)(buf + 1) = header;

    // k{
    Compresser *comp = new Compresser(
		(char*)(buf + 39),
		(int)(buf_size - 39),
		(const byte *)buf_src,
		src_size,
		header
		);
	int body_size = comp->compress();
	delete comp;

    return 39 + body_size;
}


// wb_쐬
void init_header(CMPHeader *header, const unsigned char *buf_src, unsigned int src_size){

	// Ioׂf[^
	//	f_byte[0]: Aŏo8bitf[^ No.1
	//	f_byte[1]: Aŏo8bitf[^ No.1'
	//	f_byte[2]: PƂŏo8bitf[^ No.1
	//	f_byte[3]: PƂŏo8bitf[^ No.1'
	//	f_word[0]: PƂŏo16bitf[^ No.1
	//	f_word[1]`f_word[16]: PƂŏo16bitf[^ No.2
	//
	// ȏ܂Ƃ߂ƁA
	//	Ao8bitf[^ 2ށA	2ɂ͏dIoĂ悢B
	//	PƏo8bitf[^ 2ށA	
	//	PƏo16bitf[^ 17
	//		̑IoƂB8bitA`ׂ̂̂EEEH
	//		A8bit * 2̌`́Af_word[0]̂قǂB

	// 3byteȏA8bit (̐łȂAA鐔d)
	int run8[256];
	for (int i=0; i<256; i++){
		run8[i] = 0;
	}

	// Pƕpx8bit
	int freq8[256];
	for (int i=0; i<256; i++){
		freq8[i] = 0;
	}

	// ܂́Aȏ2ނ̃e[uB
	int n = 0;
	unsigned char c, back=0;
	for (unsigned int i=0; i<src_size; i++){
		c = buf_src[i];
		freq8[c]++;
		if (c == back){
			n++;
			if (n >= 3){
				run8[c]++;
			}
		}else{
			n = 0;
		}
		back = c;
	}

	// 8bit̕pxe[uƂɁAf_byte[0]`f_byte[3]B
	int max = 0;
	for (int i=0; i<256; i++){
		if (run8[i] > max){
			max = run8[i];
			header->f_byte[0] = (byte)i;
		}
	}
	if (max == 0) header->f_byte[0] = 0;
	max = 0;
	for (int i=0; i<256; i++){
		if (run8[i] > max && i != header->f_byte[0]){
			max = run8[i];
			header->f_byte[1] = (byte)i;
		}
	}
	if (max == 0) header->f_byte[1] = 0;

	max = 0;
	for (int i=0; i<256; i++){
		if (freq8[i] > max){
			max = freq8[i];
			header->f_byte[2] = (byte)i;
		}
	}
	max = 0;
	for (int i=0; i<256; i++){
		if (freq8[i] > max && i != header->f_byte[2]){
			max = freq8[i];
			header->f_byte[3] = (byte)i;
		}
	}

	// 16bit̕pxA܂ƂɃe[u킯ɂȂ̂ŁAeJ@ŁB
	std::map<word, WORD> freq16;
	for (int i=0; i<400; i++){
		int p = rand() % (src_size-1);
		word w = *(word*)(buf_src + p);
		std::map<word, WORD>::iterator it = freq16.find(w);
		if (it == freq16.end()){
			freq16.insert(std::pair<word, WORD>(w, 1));
		}else{
			(*it).second++;
		}
	}

	// px}bvf_wordB
	for (int r=0; r<16; r++){
		max = 0;
		for (std::map<word, WORD>::iterator i=freq16.begin(), i_end=freq16.end(); i!=i_end; i++){
			if ((*i).second > max){
				if (r > 0 && (*i).first == header->f_word[0]) continue;
				if (r > 1 && (*i).first == header->f_word[1]) continue;
				if (r > 2 && (*i).first == header->f_word[2]) continue;
				if (r > 3 && (*i).first == header->f_word[3]) continue;
				if (r > 4 && (*i).first == header->f_word[4]) continue;
				if (r > 5 && (*i).first == header->f_word[5]) continue;
				if (r > 6 && (*i).first == header->f_word[6]) continue;
				if (r > 7 && (*i).first == header->f_word[7]) continue;
				if (r > 8 && (*i).first == header->f_word[8]) continue;
				if (r > 9 && (*i).first == header->f_word[9]) continue;
				if (r >10 && (*i).first == header->f_word[10]) continue;
				if (r >11 && (*i).first == header->f_word[11]) continue;
				if (r >12 && (*i).first == header->f_word[12]) continue;
				if (r >13 && (*i).first == header->f_word[13]) continue;
				if (r >14 && (*i).first == header->f_word[14]) continue;
				max = (*i).second;
				header->f_word[r] = (*i).first;
			}
		}
	}

	


	return;
}






