
///////////////////////////////////////////////////////////////////////////////
//
//	isd.h
//

#ifndef _ISD_
#define _ISD_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "window.h"
#include "base.h"


#define INVALID_STYLE ((WORD)0xFFFF)


class ProjectManager;



//	LevelISD: Xe[W̓X^Cf[^
//---------------------------------------------------------
struct LevelISD{

	static const size_t SIZE = 21;

	BYTE palette1;
	BYTE effect;
	BYTE music;
	WORD palette2;
	WORD pointer1;
	WORD pointer2;
	BYTE fg_scroll;
	BYTE tilemap_graph;
	BYTE redraw;
	BYTE tilemap_scroll;
	BYTE map_num;
	BYTE view_thg;
	BYTE special_action;

	void load_data(const ProjectManager *project, BANK bank, SADRS adrs);
	void store_data(ProjectManager *project, BANK bank, SADRS adrs);

};




//	ISDManager: Xe[W̓X^CǗ
//---------------------------------------------------------
class ISDManager : public RomData_Base{

	friend class ISDSelectDialog;
	friend class ISDEditDialog;
	friend class ISDEdit_UndoMethod;

private:

	ProjectManager *project;
	BANK style_bank;
	WORD style_begin;
	int style_count;
	char (*style_name)[256];
	LevelISD *data;

public:

	ISDManager(ProjectManager *_project);
	~ISDManager();

	void load();	// ROMobt@ǂݍ
	void save();	// ROMobt@ɏ


	const char *get_style_name(WORD style);
	int get_style_count();
	WORD get_style_begin();
	BANK get_style_bank();

	const LevelISD *get_style_data(WORD style);

	int style_edit_dialog(HWND hw_owner, WORD init_style);
	WORD style_select_dialog(HWND hw_owner, WORD init_style);
	BOOL command(WPARAM wParam, LPARAM lParam);
	void set_state(BOOL bEnabled);

};




///////////////////////////////////////////////////////////////////////////////

#endif // _ISD_


