
///////////////////////////////////////////////////////////////////////////////
//
//	level_select.cpp
//

#include <stdio.h>
#include "id.h"
#include "level_select.h"


LPCSTR LevelSelectDialog::get_template() const{
	return "LEVEL_SELECT";
}



BOOL LevelSelectDialog::Proc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	switch (msg){
		case WM_INITDIALOG:
			{
				char s[128];
				char level_name[64];
				char n[8];
				int level_count = GetPrivateProfileInt("Levels", "Count", 206, RomInfoFileName);
				HWND hwList = GetDlgItem(hWnd, IDC_LIST0);
				for (int i=0; i<level_count; i++){
					sprintf_s(n, sizeof n, "%02X", i);
					GetPrivateProfileString("LevelName", n, "?", level_name, sizeof level_name, RomInfoFileName);
					sprintf_s(s, sizeof s, "%s: %s", n, level_name);
					SendMessage(hwList, LB_INSERTSTRING, (WPARAM)i, (LPARAM)s);
				}
				SendMessage(hwList, LB_SETCURSEL, (WPARAM)lParam, (LPARAM)0);
			}
			return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam)){
				case IDC_LIST0:
					if (HIWORD(wParam) == LBN_DBLCLK){
						SendMessage(hWnd, WM_COMMAND, IDOK, (LPARAM)0);
						return TRUE;
					}
					return FALSE;
				case IDOK:
					EndDialog(hWnd, (INT_PTR)SendMessage(GetDlgItem(hWnd, IDC_LIST0), LB_GETCURSEL, 0, 0));
					return TRUE;
				case IDCANCEL:
					EndDialog(hWnd, (INT_PTR)-1);
					return TRUE;
			}
			return FALSE;
	}
	return FALSE;
}









