
///////////////////////////////////////////////////////////////////////////////
//
//	level_tileact.cpp
//

#include "id.h"
#include "project.h"


void LevelTilemapManager::write_action_chips(){
	int x, y;
	WORD tile, action;
	HDC hdc_action = action_chip.get_HDC();
	action_chip.select_object(GetStockObject(BLACK_BRUSH));
	action_chip.select_object(GetStockObject(BLACK_PEN));
	action_chip.rectangle(0, 0, 2048, 2048);
	for (int i=0; i<actionmap_size; i++){
		x = (i%16)*32;
		y = (i/16)*32;
		tile = i>=actionmap_size ? 0 : i;
		action = LOWORD(actionmap[tile]);
		draw_action(x, y, action);
		/*
			SetTextColor(hdc_action, RGB(0, 0, 255));
			SetBkMode(hdc_action, TRANSPARENT);
			SelectObject(hdc_action, GetStockObject(DEFAULT_GUI_FONT));
			char s[16];
			sprintf_s(s, sizeof s, "%02X", action&0x7F);
			TextOut(hdc_action, x, y, s, strlen(s));
		//*/
		action = HIWORD(actionmap[tile]);
		draw_action(x+16, y, action);
		/*
			sprintf_s(s, sizeof s, "%02X", action&0x7F);
			TextOut(hdc_action, x+16, y+12, s, strlen(s));
		//*/
		StretchBlt(hdc_action, x+512+31, y, -32, 32, hdc_action, x, y, 32, 32, SRCCOPY);
		StretchBlt(hdc_action, x+1024, y+31, 32,-32, hdc_action, x, y, 32, 32, SRCCOPY);
		StretchBlt(hdc_action, x+1536, y+31, 32,-32, hdc_action, x+512, y, 32, 32, SRCCOPY);
	}
	/*		// `bvƂ̑ꑮt@Cɏo
	BYTE *bPixelBits = new BYTE[4*2048*2048];
	BITMAPINFO bmpInfo;
	ZeroMemory(&bmpInfo, sizeof bmpInfo);
	bmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmpInfo.bmiHeader.biWidth = 2048;
	bmpInfo.bmiHeader.biHeight = 2048;
	bmpInfo.bmiHeader.biPlanes = 1;
	bmpInfo.bmiHeader.biBitCount = 32;
	bmpInfo.bmiHeader.biCompression = BI_RGB;
	bmpInfo.bmiHeader.biSizeImage = 4*2048*2048;
	bmpInfo.bmiHeader.biXPelsPerMeter = 0;
	bmpInfo.bmiHeader.biYPelsPerMeter = 0;
	bmpInfo.bmiHeader.biClrUsed = 0;
	bmpInfo.bmiHeader.biClrImportant = 0;
	GetDIBits(
		hdc_action, action_chip.get_bitmap(), 0 , 2048,
		bPixelBits , &bmpInfo, DIB_RGB_COLORS
	);
	HANDLE hFile = CreateFile("out.bmp", GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL, NULL);
	DWORD dwBytes;
	BITMAPFILEHEADER bmpFileHeader;
	bmpFileHeader.bfType = 0x4D42;
	bmpFileHeader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + 4*2048*2048;
	bmpFileHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	bmpFileHeader.bfReserved1 = 0;
	bmpFileHeader.bfReserved2 = 0;
	WriteFile(hFile, &bmpFileHeader, sizeof(BITMAPFILEHEADER), &dwBytes , NULL);
	WriteFile(hFile, &bmpInfo, sizeof(BITMAPINFOHEADER), &dwBytes, NULL);
	WriteFile(hFile, bPixelBits, 4*2048*2048, &dwBytes, NULL);
	CloseHandle(hFile);
	delete[] bPixelBits;
	//*/
	return;
}

void LevelTilemapManager::draw_action_horizontal(int x, int y, int depth, bool hup, bool p0){
	action_chip.select_object(p0 ? hpnType1 : hpnNormal);
	action_chip.select_object(p0 ? hbrType1 : hbrNormal);
	if (hup){
		MoveToEx(action_chip.get_HDC(), x, y+depth, NULL);
		LineTo(action_chip.get_HDC(), x+16, y+depth);
	}else{
		action_chip.rectangle(x, y+depth, x+16, y+32);
	}
}

void LevelTilemapManager::draw_action_saka(int x, int y, int gnum, int height, bool hup, bool p0, bool hflip){
	static int fx[][17] = {
		{0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3,					4},
		{0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7,					8},
		{0, 1, 1, 2, 3, 3, 4, 5, 5, 6, 7, 7, 8, 9, 10, 11,					12},
		{0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14 ,15,				16},
		{0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24, 26, 28, 30,			32},
		{0, 4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60,		64},
		{-1, -1, -1, -1, 0, 4, 8, 12, 16, 16, 16, 16, 16, 16, 16, 16,		16},
		{16, 16, 16, 16, 16, 16, 16, 16, 16, 20, 24, 28, 32, 32, 32, 32,	32},
		{0, 2, 4, 6, 8, 10,	12, 14, 16, 16, 16, 16, 16, 16, 16, 16,			16},
		{16, 16, 16, 16, 16, 16, 16, 16, 16, 18, 20, 22, 24, 26, 28, 30,	32},
	};
	if (gnum<0 || gnum>=10) return;
	int g, gn;
	action_chip.select_object(p0 ? hpnType1 : hpnNormal);
	if (hup){
		for (int i=0; i<16; i++){
			g = fx[gnum][i]+height;
			//if (g < 0 || g >=32) continue;
			if (g<0) continue;
			if (g>=32) g=31;
			gn = fx[gnum][i+1]+height;
			if (gn==g) gn++;
			if (gn>32) gn=32;
			MoveToEx(action_chip.get_HDC(), x+(hflip ? 15-i : i), y+31-g, NULL);
			LineTo(action_chip.get_HDC(), x+(hflip ? 15-i : i), y+31-gn);
		}
	}else{
		for (int i=0; i<16; i++){
			g = fx[gnum][i]+height;
			gn = fx[gnum][i+1]+height;
			if (gn<0) continue;
			if (gn==g) gn++;
			if (gn>32) gn=32;
			MoveToEx(action_chip.get_HDC(), x+(hflip ? 15-i : i), y+31, NULL);
			LineTo(action_chip.get_HDC(), x+(hflip ? 15-i : i), y+31-gn);
		}
	}
}

void LevelTilemapManager::draw_action(int x, int y, WORD action){
	int number = action & 0x007F;
	bool hflip = (action & 0x8000) != 0;
	bool hup = (action & 0x4000) != 0;
	bool p0 = (action & 0x0100) != 0;
	switch (number){
		case 0x00: break;
		case 0x01: draw_action_horizontal(x, y, 0, hup, p0); break;
		case 0x02: draw_action_horizontal(x, y, 4, hup, p0); break;
		case 0x03: draw_action_horizontal(x, y, 8, hup, p0); break;
		case 0x04: draw_action_horizontal(x, y, 12, hup, p0); break;
		case 0x05: draw_action_horizontal(x, y, 16, hup, p0); break;
		case 0x06: draw_action_horizontal(x, y, 20, hup, p0); break;
		case 0x07: draw_action_horizontal(x, y, 24, hup, p0); break;
		case 0x08: draw_action_horizontal(x, y, 28, hup, p0); break;
		case 0x09: draw_action_saka(x, y, 0, 0, hup, p0, hflip); break;
		case 0x0A: draw_action_saka(x, y, 0, 4, hup, p0, hflip); break;
		case 0x0B: draw_action_saka(x, y, 0, 8, hup, p0, hflip); break;
		case 0x0C: draw_action_saka(x, y, 0, 12, hup, p0, hflip); break;
		case 0x0D: draw_action_saka(x, y, 0, 16, hup, p0, hflip); break;
		case 0x0E: draw_action_saka(x, y, 0, 20, hup, p0, hflip); break;
		case 0x0F: draw_action_saka(x, y, 0, 24, hup, p0, hflip); break;
		case 0x10: draw_action_saka(x, y, 0, 28, hup, p0, hflip); break;
		case 0x11: draw_action_saka(x, y, 1, -4, hup, p0, hflip); break;
		case 0x12: draw_action_saka(x, y, 1, 0, hup, p0, hflip); break;
		case 0x13: draw_action_saka(x, y, 1, 4, hup, p0, hflip); break;
		case 0x14: draw_action_saka(x, y, 1, 8, hup, p0, hflip); break;
		case 0x15: draw_action_saka(x, y, 1, 12, hup, p0, hflip); break;
		case 0x16: draw_action_saka(x, y, 1, 16, hup, p0, hflip); break;
		case 0x17: draw_action_saka(x, y, 1, 20, hup, p0, hflip); break;
		case 0x18: draw_action_saka(x, y, 1, 24, hup, p0, hflip); break;
		case 0x19: draw_action_saka(x, y, 1, 28, hup, p0, hflip); break;
		case 0x1A: draw_action_saka(x, y, 2, -8, hup, p0, hflip); break;
		case 0x1B: draw_action_saka(x, y, 2, -4, hup, p0, hflip); break;
		case 0x1C: draw_action_saka(x, y, 2, 0, hup, p0, hflip); break;
		case 0x1D: draw_action_saka(x, y, 2, 4, hup, p0, hflip); break;
		case 0x1E: draw_action_saka(x, y, 2, 8, hup, p0, hflip); break;
		case 0x1F: draw_action_saka(x, y, 2, 12, hup, p0, hflip); break;
		case 0x20: draw_action_saka(x, y, 2, 16, hup, p0, hflip); break;
		case 0x21: draw_action_saka(x, y, 2, 20, hup, p0, hflip); break;
		case 0x22: draw_action_saka(x, y, 2, 24, hup, p0, hflip); break;
		case 0x23: draw_action_saka(x, y, 2, 28, hup, p0, hflip); break;
		case 0x24: draw_action_saka(x, y, 3, -12, hup, p0, hflip); break;
		case 0x25: draw_action_saka(x, y, 3, -8, hup, p0, hflip); break;
		case 0x26: draw_action_saka(x, y, 3, -4, hup, p0, hflip); break;
		case 0x27: draw_action_saka(x, y, 3, 0, hup, p0, hflip); break;
		case 0x28: draw_action_saka(x, y, 3, 4, hup, p0, hflip); break;
		case 0x29: draw_action_saka(x, y, 3, 8, hup, p0, hflip); break;
		case 0x2A: draw_action_saka(x, y, 3, 12, hup, p0, hflip); break;
		case 0x2B: draw_action_saka(x, y, 3, 16, hup, p0, hflip); break;
		case 0x2C: draw_action_saka(x, y, 3, 20, hup, p0, hflip); break;
		case 0x2D: draw_action_saka(x, y, 3, 24, hup, p0, hflip); break;
		case 0x2E: draw_action_saka(x, y, 3, 28, hup, p0, hflip); break;
		case 0x2F: draw_action_saka(x, y, 4, -24, hup, p0, hflip); break;
		case 0x30: draw_action_saka(x, y, 4, -16, hup, p0, hflip); break;
		case 0x31: draw_action_saka(x, y, 4, -8, hup, p0, hflip); break;
		case 0x32: draw_action_saka(x, y, 4, 0, hup, p0, hflip); break;
		case 0x33: draw_action_saka(x, y, 4, 8, hup, p0, hflip); break;
		case 0x34: draw_action_saka(x, y, 4, 16, hup, p0, hflip); break;
		case 0x35: draw_action_saka(x, y, 4, 24, hup, p0, hflip); break;
		case 0x36: draw_action_saka(x, y, 5, -48, hup, p0, hflip); break;
		case 0x37: draw_action_saka(x, y, 5, -32, hup, p0, hflip); break;
		case 0x38: draw_action_saka(x, y, 5, -16, hup, p0, hflip); break;
		case 0x39: draw_action_saka(x, y, 5, 0, hup, p0, hflip); break;
		case 0x3A: draw_action_saka(x, y, 5, 16, hup, p0, hflip); break;
		case 0x3B: draw_action_saka(x, y, 6, 0, hup, p0, hflip); break;
		case 0x3C: draw_action_saka(x, y, 7, 0, hup, p0, hflip); break;
		case 0x3D: draw_action_horizontal(x, y, 0, hup, p0); break;
		case 0x3E: draw_action_horizontal(x, y, 16, hup, p0); break;
		case 0x3F:
			action_chip.select_object(p0 ? hpnType1 : hpnNormal);
			action_chip.select_object(p0 ? hbrType1 : hbrNormal);
			if (hup){
				MoveToEx(action_chip.get_HDC(), hflip?x+12:x, y+12, NULL);
				LineTo(action_chip.get_HDC(), hflip?x+16:x+4, y+12);
			}else{
				action_chip.rectangle(hflip?x+12:x, y+12, hflip?x+16:x+4, y+32);
			}
			action_chip.select_object(hpnType3);
			action_chip.select_object(hbrType3);
			//action_chip.rectangle(hflip?x:x+4, y+12, hflip?x+12:x+16, y+32);
			action_chip.rectangle(hflip?x+12:x, y+12, hflip?x+16:x+4, y+32);
			break;
		case 0x40:
			action_chip.select_object(hpnType3);
			action_chip.select_object(hbrType3);
			//action_chip.rectangle(x, y+10, x+16, y+22);
			action_chip.rectangle(x, y+14, x+16, y+18);
			break;
		case 0x41:
			action_chip.select_object(hpnType3);
			action_chip.select_object(hbrType3);
			//action_chip.rectangle(hflip?x:x+4, y, hflip?x+12:x+16, y+32);
			action_chip.rectangle(hflip?x+12:x, y, hflip?x+16:x+4, y+32);
			break;
		case 0x42:
			action_chip.select_object(hpnType3);
			action_chip.select_object(hbrType3);
			//action_chip.rectangle(hflip?x+12:x, y+10, hflip?x+16:x+4, y+22);
			//action_chip.rectangle(hflip?x:x+4, y, hflip?x+12:x+16, y+32);
			action_chip.rectangle(hflip?x:x+4, y+14, hflip?x+12:x+16, y+18);
			action_chip.rectangle(hflip?x+12:x, y, hflip?x+16:x+4, y+32);
			break;
		case 0x43:
			action_chip.select_object(hpnType3);
			action_chip.select_object(hbrType3);
			//action_chip.rectangle(hflip?x:x+4, y, hflip?x+12:x+16, y+24);
			action_chip.rectangle(hflip?x+12:x, y, hflip?x+16:x+4, y+24);
			break;
		case 0x44:
			action_chip.select_object(hpnType3);
			action_chip.select_object(hbrType3);
			//action_chip.rectangle(hflip?x:x+4, y, hflip?x+12:x+16, y+16);
			action_chip.rectangle(hflip?x+12:x, y, hflip?x+16:x+4, y+16);
			break;
		case 0x45:
			action_chip.select_object(hpnType3);
			action_chip.select_object(hbrType3);
			//action_chip.rectangle(hflip?x:x+4, y, hflip?x+12:x+16, y+8);
			action_chip.rectangle(hflip?x+12:x, y, hflip?x+16:x+4, y+8);
			break;
		case 0x46:
			action_chip.select_object(p0 ? hpnType1 : hpnNormal);
			action_chip.select_object(p0 ? hbrType1 : hbrNormal);
			if (hup){
				MoveToEx(action_chip.get_HDC(), hflip?x+12:x, y+12, NULL);
				LineTo(action_chip.get_HDC(), hflip?x+16:x+4, y+12);
			}else{
				action_chip.rectangle(hflip?x+12:x, y+12, hflip?x+16:x+4, y+32);
			}
			action_chip.select_object(hpnType3);
			action_chip.select_object(hbrType3);
			//action_chip.rectangle(hflip?x:x+4, y, hflip?x+12:x+16, y+32);
			action_chip.rectangle(hflip?x+12:x, y, hflip?x+16:x+4, y+32);
			break;
		case 0x47:
			action_chip.select_object(hpnType2);
			action_chip.select_object(hbrType2);
			if (hup){
				MoveToEx(action_chip.get_HDC(), x, y, NULL);
				LineTo(action_chip.get_HDC(), x+16, y);
			}else{
				action_chip.rectangle(x, y, x+16, y+32);
			}
			break;
		case 0x48:
			action_chip.select_object(hpnType2);
			action_chip.select_object(hbrType2);
			if (hup){
				MoveToEx(action_chip.get_HDC(), x, y+16, NULL);
				LineTo(action_chip.get_HDC(), x+16, y+16);
			}else{
				action_chip.rectangle(x, y+16, x+16, y+32);
			}
			break;
		case 0x49: draw_action_saka(x, y, 8, 0, hup, p0, hflip); break;
		case 0x4A: draw_action_saka(x, y, 9, 0, hup, p0, hflip); break;
		case 0x4B:
			action_chip.select_object(p0 ? hpnType1 : hpnNormal);
			action_chip.select_object(p0 ? hbrType1 : hbrNormal);
			for (int i=0; i<16; i++){
				MoveToEx(action_chip.get_HDC(), x+(hflip ? 15-i : i), y, NULL);
				LineTo(action_chip.get_HDC(), x+(hflip ? 15-i : i), y+16+15-i);
			}
			break;
		case 0x4C:
			action_chip.select_object(p0 ? hpnType1 : hpnNormal);
			action_chip.select_object(p0 ? hbrType1 : hbrNormal);
			for (int i=0; i<16; i++){
				MoveToEx(action_chip.get_HDC(), x+(hflip ? 15-i : i), y, NULL);
				LineTo(action_chip.get_HDC(), x+(hflip ? 15-i : i), y+15-i);
			}
			break;
		case 0x4D:
			action_chip.select_object(p0 ? hpnType1 : hpnNormal);
			action_chip.select_object(p0 ? hbrType1 : hbrNormal);
			action_chip.rectangle(x, y, x+16, y+16);
			break;
		case 0x4E:
			action_chip.select_object(p0 ? hpnType1 : hpnNormal);
			action_chip.select_object(p0 ? hbrType1 : hbrNormal);
			for (int i=0; i<16; i++){
				MoveToEx(action_chip.get_HDC(), x+(hflip ? 15-i : i), y, NULL);
				LineTo(action_chip.get_HDC(), x+(hflip ? 15-i : i), y+(15-i)*2);
			}
			break;
		case 0x4F:
			action_chip.select_object(p0 ? hpnType1 : hpnNormal);
			action_chip.select_object(p0 ? hbrType1 : hbrNormal);
			if (hup){
				MoveToEx(action_chip.get_HDC(), hflip?x+8:x, y, NULL);
				LineTo(action_chip.get_HDC(), hflip?x+16:x+8, y);
			}else{
				action_chip.rectangle(hflip?x+8:x, y, hflip?x+16:x+8, y+32);
			}
			break;
	}
	return;
}



