
///////////////////////////////////////////////////////////////////////////////
//
//	level_tilemap.h
//

#ifndef _LEVEL_TILEMAP_
#define _LEVEL_TILEMAP_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "base.h"
#include "window.h"
#include "gdi.h"
#include "level_setting.h"


class ProjectManager;
class LevelManager;
struct LevelSettingData;
struct LevelISD;
struct MapData;


//	LevelTilemapManager: n`Ǘ
//---------------------------------------------------------
class LevelTilemapManager : public RomData_Base, public UI_Base{

	DWORD *actionmap;
	int actionmap_size;

	WORD *tilemap_org;
	WORD *tilemap;
	bool map_valid;
	bool map_vert;
	int map_cx;
	int map_cy;
	WORD map_code;

	enum ShowTilemapType{
		MAP_HIDE=0,
		MAP_TILEMAP,
		MAP_ACTION
	} iShowTilemap;

	HPEN	hpnNormal;
	HPEN	hpnType1;
	HPEN	hpnType2;
	HPEN	hpnType3;
	HBRUSH	hbrNormal;
	HBRUSH	hbrType1;
	HBRUSH	hbrType2;
	HBRUSH	hbrType3;


	BitmapBuffer action_chip;
	BitmapBuffer map_chip;
	ProjectManager *project;
	LevelManager *level;

	bool load_tilemap(const LevelSettingData *setting, const MapData *map_data);
	bool load_chipdata(const LevelISD *style, const MapData *map_data);
	void load_whole_palette(RGBQUAD palette[], BANK bank, SADRS adrs);
	void load_partial_palette(RGBQUAD palette[], BANK bank, SADRS adrs, int iStart, int iCount);
	void write_action_chips();
	void draw_action(int x, int y, WORD action);
	void draw_action_horizontal(int x, int y, int depth, bool hup, bool p0);
	void draw_action_saka(int x, int y, int gnum, int height, bool hup, bool p0, bool hflip);
	void set_menuitem_state();

public:

	LevelTilemapManager(LevelManager *_level, ProjectManager *_project);
	~LevelTilemapManager();

	BOOL create();
	void save_data();
	void load(const LevelSettingData *setting, HDC hdc_wnd);
	bool get_vert() const{ return map_vert; }
	int get_cx() const{ return map_cx; }
	int get_cy() const{ return map_cy; }
	WORD get_code() const{ return map_code; }
	bool is_valid() const{ return map_valid; }

	void draw(BitmapBuffer *buf, const RECT *rtRedraw);
	BOOL command(WPARAM wParam, LPARAM lParam);

};




///////////////////////////////////////////////////////////////////////////////

#endif // _LEVEL_TILEMAP_



