
///////////////////////////////////////////////////////////////////////////////
//
//	maps.h
//

#ifndef _MAPS_
#define _MAPS_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "window.h"
#include "base.h"


class ProjectManager;


//	MapData: }bv̏
//---------------------------------------------------------
struct MapData{
	LADRS tilemap_adrs;
	LADRS chip_method_adrs;
	WORD  layer_info;
	LADRS action_map;
	WORD  action_map_size;
	SADRS special_action_adrs;
	WORD  tilemap_color;
	WORD  tilemap_type;
	SADRS allocation_adrs;
};


//	MapsManager: }bvǗ
//---------------------------------------------------------
class MapsManager : public RomData_Base{

	friend class TilemapDialog;
	friend class Tilemap_UndoMethod;
	friend class MapEditDialog;
	friend class MapEdit_UndoMethod;

private:

	ProjectManager *project;

	// rominfo.ini瓾f[^
	int map_count;
	LADRS pTilemapAdrs;
	LADRS pChipMethodAdrs;
	LADRS pLayerInfo;
	LADRS pActionMap;
	LADRS pActionMapSize;
	LADRS pSpActionAdrs;
	LADRS pTilemapColor;
	LADRS pTilemapType;
	LADRS pAllocationAdrs;
	char (*map_name)[256];

	// ROMɓǂݏf[^
	MapData *data;

public:

	MapsManager(ProjectManager *_project);
	~MapsManager();

	void load();
	void save();
	const char *get_map_name(int map_num);
	const MapData *get_map_data(int map_num);
	size_t get_tilemap_max_size(int map_num);
	void get_tilemap_attribute(int map_num, bool *bVert, int *width);
	void get_tilemap_attribute(const MapData *map_data, bool *bVert, int *width);
	void get_chip_file(int map_num, char *buf, size_t buf_size);
	void get_chip_file_me(int map_num, char *buf, size_t buf_size);
	int map_edit_dialog(HWND hw_owner, int init_map_num);
	int tilemap_edit_dialog(HWND hw_owner, int init_map_num, int init_map_index);
	BOOL command(WPARAM wParam, LPARAM lParam);
	void set_state(BOOL bEnabled);
	BANK get_map_bank() const{ return pTilemapAdrs.bank; }

};




///////////////////////////////////////////////////////////////////////////////

#endif // _MAPS_







