
///////////////////////////////////////////////////////////////////////////////
//
//	fmf_io_me.cpp
//

#include "platinum_def.h"



bool OutputPPJ_MapEdit(
	LPCSTR filename,
	const WORD *buf_src,
	DWORD width,
	DWORD height,
	bool bVert,
	LPCSTR chip_filename
	)
{

	char _filename[MAX_PATH];
	strcpy_s(_filename, sizeof _filename, filename);

	HMMIO hmmio = mmioOpen(_filename, NULL, MMIO_CREATE | MMIO_WRITE);
	if (hmmio == NULL) return false;

	// [g`N
	MMCKINFO cki_root;
	cki_root.ckid = mmioFOURCC('R', 'I', 'F', 'F');
	cki_root.fccType = mmioFOURCC('U', 'M', 'F', '_');
	if (mmioCreateChunk(hmmio, &cki_root, MMIO_CREATERIFF) != MMSYSERR_NOERROR){
		mmioClose(hmmio, 0);
		return false;
	}{

		MMCKINFO cki1;

		// UMFh`N
		cki1.ckid = mmioFOURCC('U', 'M', 'F', 'h');
		if (mmioCreateChunk(hmmio, &cki1, 0) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{
			UMFHeader header;
			header.map_width	= width;
			header.map_height	= height;
			header.chip_width	= 32;
			header.chip_height	= 32;
			header.layer_count	= 1;
			header.bit_count	= 16;
			header.relative_path= 1;
			header.reserved		= 0;
			mmioWrite(hmmio, (const char *)&header, sizeof header);
		} mmioAscend(hmmio, &cki1, 0);

		// Ver_`N
		cki1.ckid = mmioFOURCC('V', 'e', 'r', '_');
		if (mmioCreateChunk(hmmio, &cki1, 0) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{
			DWORD version = 0x66010601;
			mmioWrite(hmmio, (const char *)&version, 4);
		} mmioAscend(hmmio, &cki1, 0);

		// EEnv`N
		cki1.ckid = mmioFOURCC('E', 'E', 'n', 'v');
		if (mmioCreateChunk(hmmio, &cki1, 0) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{
			BYTE eenv[6] = {0x00, 0x00, 0x00, 0x01, 0x00, 0x00};
			mmioWrite(hmmio, (const char *)eenv, 6);
		} mmioAscend(hmmio, &cki1, 0);

		// ColK`N
		cki1.ckid = mmioFOURCC('C', 'o', 'l', 'K');
		if (mmioCreateChunk(hmmio, &cki1, 0) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{
			BYTE colk[6] = {0x00, 0x00, 0xFF, 0x00, 0x00, 0xFF};
			mmioWrite(hmmio, (const char *)colk, 6);
		} mmioAscend(hmmio, &cki1, 0);

		// Grid`N
		cki1.ckid = mmioFOURCC('G', 'r', 'i', 'd');
		if (mmioCreateChunk(hmmio, &cki1, 0) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{
			BYTE grid[8] = {0x80, 0x80, 0x80, 0x00, 0xFF, 0x00, 0x00, 0x00};
			mmioWrite(hmmio, (const char *)grid, 8);
		} mmioAscend(hmmio, &cki1, 0);

		// Zoom`N
		cki1.ckid = mmioFOURCC('Z', 'o', 'o', 'm');
		if (mmioCreateChunk(hmmio, &cki1, 0) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{
			WORD zoom = 0x00E0;
			mmioWrite(hmmio, (const char *)&zoom, 2);
		} mmioAscend(hmmio, &cki1, 0);

		// InvC`N
		cki1.ckid = mmioFOURCC('I', 'n', 'v', 'C');
		if (mmioCreateChunk(hmmio, &cki1, 0) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{
			BYTE invc[4] = {0x01, 0xFF, 0x00, 0xFF};
			mmioWrite(hmmio, (const char *)invc, 4);
		} mmioAscend(hmmio, &cki1, 0);

		// LIST: LAY_ `N(C[)
		cki1.ckid = mmioFOURCC('L', 'I', 'S', 'T');
		cki1.fccType = mmioFOURCC('L', 'A', 'Y', '_');
		if (mmioCreateChunk(hmmio, &cki1, MMIO_CREATELIST) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{

			MMCKINFO cki2;

			// LSTR`N(C[)
			cki2.ckid = mmioFOURCC('L', 'S', 'T', 'R');
			if (mmioCreateChunk(hmmio, &cki2, 0) != MMSYSERR_NOERROR){
				mmioClose(hmmio, 0);
				return false;
			}{
				char *lstr = "C[0";
				mmioWrite(hmmio, lstr, strlen(lstr));
			} mmioAscend(hmmio, &cki2, 0);

			// PSTR`N(`bvt@C)
			cki2.ckid = mmioFOURCC('P', 'S', 'T', 'R');
			if (mmioCreateChunk(hmmio, &cki2, 0) != MMSYSERR_NOERROR){
				mmioClose(hmmio, 0);
				return false;
			}{
				mmioWrite(hmmio, chip_filename, strlen(chip_filename));
			} mmioAscend(hmmio, &cki2, 0);

			// LINV`N()
			cki2.ckid = mmioFOURCC('L', 'I', 'N', 'V');
			if (mmioCreateChunk(hmmio, &cki2, 0) != MMSYSERR_NOERROR){
				mmioClose(hmmio, 0);
				return false;
			}{
				BYTE linv = 1;
				mmioWrite(hmmio, (const char *)&linv, 1);
			} mmioAscend(hmmio, &cki2, 0);

			// LDAT`N(`bvz)
			cki2.ckid = mmioFOURCC('L', 'D', 'A', 'T');
			if (mmioCreateChunk(hmmio, &cki2, 0) != MMSYSERR_NOERROR){
				mmioClose(hmmio, 0);
				return false;
			}{

				DWORD x, y;
				WORD chip;
				WORD hvflip;

				if (bVert){
					for (y=0; y<height; y++){
						for (x=0; x<width; x++){
							chip = buf_src[x + y*width];
							hvflip = chip & 0xC000;
							chip &= 0x3fff;
							chip = (chip&0x003f) | ((chip&0x03c0) << 2) | (hvflip >> 2);
							mmioWrite(hmmio, (const char *)&chip, 2);
						}
					}
				}else{
					for (y=0; y<height; y++){
						for (x=0; x<width; x++){
							chip = buf_src[x*height + y];
							hvflip = chip & 0xC000;
							chip &= 0x3fff;
							chip = (chip&0x003f) | ((chip&0x03c0) << 2) | (hvflip >> 2);
							mmioWrite(hmmio, (const char *)&chip, 2);
						}
					}
				}

			} mmioAscend(hmmio, &cki2, 0);

		} mmioAscend(hmmio, &cki1, 0);

	} mmioAscend(hmmio, &cki_root, 0);

	mmioClose(hmmio, 0);

	return true;
}



bool InputPPJ_MapEdit(LPCSTR filename, WORD *buf, DWORD buf_size, DWORD *width, DWORD *height, bool bVert){

	char _filename[MAX_PATH];
	strcpy_s(_filename, sizeof _filename, filename);

	HMMIO hmmio = mmioOpen(_filename, NULL, MMIO_READ);
	if (hmmio == NULL) return false;

	// [g`N
	MMCKINFO cki_root;
	cki_root.ckid = mmioFOURCC('R', 'I', 'F', 'F');
	cki_root.fccType = mmioFOURCC('U', 'M', 'F', '_');
	if (mmioDescend(hmmio, &cki_root, NULL, MMIO_FINDRIFF) != MMSYSERR_NOERROR){
		mmioClose(hmmio, 0);
		return false;
	}{

		MMCKINFO cki1;

		// UMFh`N
		cki1.ckid = mmioFOURCC('U', 'M', 'F', 'h');
		if (mmioDescend(hmmio, &cki1, NULL, MMIO_FINDCHUNK) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{
			UMFHeader header;
			mmioRead(hmmio, (HPSTR)&header, sizeof header);
			*width  = header.map_width;
			*height = header.map_height;
			if (header.bit_count != 16 || (*width)*(*height) > buf_size){
				// rbgsA܂̓obt@s
				mmioClose(hmmio, 0);
				return false;
			}
		} mmioAscend(hmmio, &cki1, 0);

		// LIST: LAY_ `N(C[)
		cki1.ckid = mmioFOURCC('L', 'I', 'S', 'T');
		cki1.fccType = mmioFOURCC('L', 'A', 'Y', '_');
		if (mmioDescend(hmmio, &cki1, NULL, MMIO_FINDLIST) != MMSYSERR_NOERROR){
			mmioClose(hmmio, 0);
			return false;
		}{

			MMCKINFO cki2;

			// LDAT`N(`bvz)
			cki2.ckid = mmioFOURCC('L', 'D', 'A', 'T');
			if (mmioDescend(hmmio, &cki2, NULL, MMIO_FINDCHUNK) != MMSYSERR_NOERROR){
				mmioClose(hmmio, 0);
				return false;
			}{

				DWORD x, y;
				WORD chip;
				WORD hvflip;

				if (bVert){
					for (y=0; y<*height; y++){
						for (x=0; x<*width; x++){
							mmioRead(hmmio, (HPSTR)&chip, 2);
							hvflip = chip & 0x3000;
							chip = ((chip & 0x0f00) >> 2) | (chip & 0x003f) | (hvflip << 2);
							buf[x + y*(*width)] = chip;
						}
					}
				}else{
					for (y=0; y<*height; y++){
						for (x=0; x<*width; x++){
							mmioRead(hmmio, (HPSTR)&chip, 2);
							hvflip = chip & 0x3000;
							chip = ((chip & 0x0f00) >> 2) | (chip & 0x003f) | (hvflip << 2);
							buf[x*(*height) + y] = chip;
						}
					}
				}

			} mmioAscend(hmmio, &cki2, 0);

		} mmioAscend(hmmio, &cki1, 0);

	} mmioAscend(hmmio, &cki_root, 0);

	mmioClose(hmmio, 0);

	return true;
}





















