
///////////////////////////////////////////////////////////////////////////////
//
//	recent.levels.cpp
//

#include <stdio.h>
#include <windows.h>
#include "id.h"
#include "level.h"



RecentLevelManager::RecentLevelManager(LevelManager *_level_manager, Window *_pwFrame)
: pwFrame(_pwFrame), level_manager(_level_manager)
{}

BOOL RecentLevelManager::create(){
	char str[64], str2[64];
	int level_num;
	HMENU hMenu = GetSubMenu(GetSubMenu(GetMenu(pwFrame->get_hWnd()), 3), 1);
	MENUITEMINFO mi;
	mi.cbSize		= sizeof mi;
	mi.fMask		= MIIM_TYPE | MIIM_ID;
	mi.fType		= MFT_STRING;
	for (int i=0; i<LEVELS_MAX; i++){
		sprintf_s(str, sizeof str, "%d", i);
		level_num = (signed)GetPrivateProfileInt("RecentLevels", str, -1, ConfigFileName);
		if (level_num == -1){
			break;
		}else{
			recent_levels.push_back(level_num);
			sprintf_s(str, sizeof str, "%02X", level_num);
			GetPrivateProfileString("LevelName", str, "?", str2, sizeof str2, RomInfoFileName);
			sprintf_s(str, sizeof str, "%02X: %s", level_num, str2);
			mi.wID			= IDM_LEVEL_RECENT_BEGIN + i;
			mi.dwTypeData	= str;
			mi.cch			= strlen(str);
			InsertMenuItem(hMenu, i, TRUE, &mi);
		}
	}
	return TRUE;
}

void RecentLevelManager::save_data(){
	LevelNumbers::iterator i, i_end=recent_levels.end();
	int n=0;
	char str[16], str2[16];
	for (i=recent_levels.begin(); i!=i_end; i++, n++){
		sprintf_s(str, sizeof str, "%d", n);
		sprintf_s(str2, sizeof str2, "%d", *i);
		WritePrivateProfileString("RecentLevels", str, str2, ConfigFileName);
	}
	for (; n<16; n++){
		sprintf_s(str, sizeof str, "%d", n);
		WritePrivateProfileString("RecentLevels", str, "-1", ConfigFileName);
	}
	return;
}


void RecentLevelManager::level_opened(int level_num){
	HMENU hMenu = GetSubMenu(GetSubMenu(GetMenu(pwFrame->get_hWnd()), 3), 1);
	LevelNumbers::iterator i, i_end=recent_levels.end();
	int n;
	MENUITEMINFO mi;
	char str[64], str2[64];
	for (i=recent_levels.begin(), n=0; i!=i_end; i++, n++){
		DeleteMenu(hMenu, 0, MF_BYPOSITION);
	}
	for (i=recent_levels.begin(), n=0; i!=i_end; i++, n++){
		if ((*i) == level_num){
			recent_levels.erase(i);
			break;
		}
	}
	if (recent_levels.size() >= LEVELS_MAX){
		recent_levels.pop_back();
	}
	recent_levels.push_front(level_num);
	mi.cbSize		= sizeof mi;
	mi.fMask		= MIIM_TYPE | MIIM_ID;
	mi.fType		= MFT_STRING;
	for (i=recent_levels.begin(), i_end=recent_levels.end(), n=0; i!=i_end; i++, n++){
		level_num = *i;
		sprintf_s(str, sizeof str, "%02X", level_num);
		GetPrivateProfileString("LevelName", str, "?", str2, sizeof str2, RomInfoFileName);
		sprintf_s(str, sizeof str, "%02X: %s", level_num, str2);
		mi.wID			= IDM_LEVEL_RECENT_BEGIN + n;
		mi.dwTypeData	= str;
		mi.cch			= strlen(str);
		InsertMenuItem(hMenu, n, TRUE, &mi);
	}
	return;
}

void RecentLevelManager::clear(){
	HMENU hMenu = GetSubMenu(GetSubMenu(GetMenu(pwFrame->get_hWnd()), 3), 1);
	LevelNumbers::iterator i, i_end=recent_levels.end();
	int n;
	for (i=recent_levels.begin(), n=0; i!=i_end; i++, n++){
		DeleteMenu(hMenu, 0, MF_BYPOSITION);
	}
	recent_levels.clear();
	return;
}

BOOL RecentLevelManager::command(WPARAM wParam, LPARAM lParam){
	WORD cmdID = LOWORD(wParam);
	if (cmdID >= IDM_LEVEL_RECENT_BEGIN && cmdID < IDM_LEVEL_RECENT_CLEAR){
		level_manager->load_level(recent_levels.at(cmdID - IDM_LEVEL_RECENT_BEGIN));
		return TRUE;
	}
	if (cmdID == IDM_LEVEL_RECENT_CLEAR){
		clear();
		return TRUE;
	}
	return FALSE;
}
















