
///////////////////////////////////////////////////////////////////////////////
//
//	sprite_edit.cpp
//

#include <windows.h>
#include <commctrl.h>
#include "sprite_edit.h"
#include "project.h"
#include "id.h"


// tHgTCYˑ̒l
static int DIALOG_MARGIN_X=5;
static int DIALOG_MARGIN_Y=5;
static int DIALOG_TEXT_Y=8;
static int DIALOG_TEXT_WIDTH=40;
static int DIALOG_TEXT_HEIGHT=12;
static int DIALOG_EDIT_HEIGHT=14;
static int DIALOG_TYPESEL_WIDTH=15;
static int DIALOG_TYPEBOX_Y=25;
static int DIALOG_TYPEBOX_HEIGHT=22;
static int DIALOG_BUTTON_WIDTH=100;
static int DIALOG_BUTTON_HEIGHT=18;
static int DIALOG_TAB_Y=55;
//static int DIALOG_MIN_WIDTH=240;
//static int DIALOG_MIN_HEIGHT=320;


EditsprManager::EditsprManager(ProjectManager *_project, SpritesManager *_sprites)
: project(_project), sprites(_sprites)
{
}

EditsprManager::~EditsprManager(){
	for (PageList::iterator i=pages.begin(), i_end=pages.end(); i!=i_end;){
		switch ((*i).type){
			case TabPage::SPRITE_PAGE:
				delete (*i).sprite_page;
				break;
			case TabPage::DATA_PAGE:
				delete (*i).data_page;
				break;
		}
		i = pages.erase(i);
	}
}

/*
BOOL EditsprManager::create(){
	if (!create_dialog(project->get_hWnd())) return FALSE;
	return TRUE;
}*/

void EditsprManager::set_state(BOOL bEnabled){
	HMENU hmMain = GetMenu(project->get_hWnd());
	UINT uState = (bEnabled ? MF_ENABLED : MF_GRAYED) | MF_BYCOMMAND;
	EnableMenuItem(hmMain, IDM_SPRITE_EDITSPR, uState);
	return;
}

BOOL EditsprManager::command(WPARAM wParam, LPARAM lParam){
	switch (LOWORD(wParam)){
		case IDM_SPRITE_EDITSPR:
			if (!bValid){
				create_dialog(project->get_hWnd());
			}
			ShowWindow(hWnd, SW_SHOW);
			SetFocus(GetDlgItem(hWnd, IDC_EDIT0));
			return TRUE;
	}
	return FALSE;
}

BOOL EditsprManager::translate_dialog_message(MSG *msg){
	if (!bValid) return FALSE;
	return IsDialogMessage(hWnd, msg);
}

BOOL EditsprManager::Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	LPNMHDR nmhdr;
	WORD id;
	switch (msg){
		case WM_INITDIALOG:
			init();
			return TRUE;
		/*case WM_SIZING:
			sizing(wParam, lParam);
			return TRUE;*/
		case WM_SIZE:
			size((SHORT)LOWORD(lParam), (SHORT)HIWORD(lParam));
			return TRUE;
		case WM_NOTIFY:
			nmhdr = (LPNMHDR)lParam;
			if (nmhdr->idFrom == IDC_TAB0 && nmhdr->code == TCN_SELCHANGE){
				tab_changed(TabCtrl_GetCurSel(nmhdr->hwndFrom));
				return TRUE;
			}
			break;
		case WM_COMMAND:
			switch (id = LOWORD(wParam)){
				case IDC_EDIT0:
					switch (HIWORD(wParam)){
						case EN_CHANGE:
							type_changed();
							return TRUE;
						case EN_SETFOCUS:
							SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDOK, 0);
							SetFocus(GetDlgItem(hWnd, IDOK));
							SetFocus(GetDlgItem(hWnd, IDC_EDIT0));
							return TRUE;
					}
					break;
				case IDC_EDIT1:
					switch (HIWORD(wParam)){
						case EN_SETFOCUS:
							SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDOK, 0);
							SetFocus(GetDlgItem(hWnd, IDOK));
							SetFocus(GetDlgItem(hWnd, IDC_EDIT1));
							return TRUE;
					}
					break;
				case IDC_BUTTON0:
					sprite_sel();
					return TRUE;
				case IDOK:
					open();
					return TRUE;
				case IDCANCEL:
					ShowWindow(hWnd, SW_HIDE);
					return TRUE;
			}
			if (id >= IDC_BUTTON0 && id <= IDC_BUTTON2F){
				// ANeBuȃ^uy[WɑM
				PageList::iterator i=pages.begin();
				int active_page = TabCtrl_GetCurSel(GetDlgItem(hWnd, IDC_TAB0));
				for (int n=0; n<active_page; n++) i++;
				switch ((*i).type){
					case TabPage::SPRITE_PAGE:
						return SendMessage((*i).sprite_page->get_hWnd(), msg, wParam, lParam);
					case TabPage::DATA_PAGE:
						return SendMessage((*i).data_page->get_hWnd(), msg, wParam, lParam);
				}
			}
			break;
		case WM_DESTROY:
			save_config();
			return TRUE;
	}
	return FALSE;
}

void EditsprManager::init(){
	// tHgTCYˑ̒lv
	RECT rt;
	POINT pt;
	GetWindowRect(GetDlgItem(hWnd, IDC_STATIC0), &rt);
	DIALOG_TEXT_WIDTH = rt.right - rt.left;
	DIALOG_TEXT_HEIGHT = rt.bottom - rt.top;
	pt.x = rt.left;
	pt.y = rt.top;
	ScreenToClient(hWnd, &pt);
	DIALOG_MARGIN_X = pt.x;
	DIALOG_TEXT_Y = pt.y;
	GetWindowRect(GetDlgItem(hWnd, IDC_BUTTON0), &rt);
	DIALOG_EDIT_HEIGHT = rt.bottom - rt.top;
	DIALOG_TYPESEL_WIDTH = rt.right - rt.left;
	pt.x = 0;
	pt.y = rt.top;
	ScreenToClient(hWnd, &pt);
	DIALOG_MARGIN_Y = pt.y;
	GetWindowRect(GetDlgItem(hWnd, IDC_EDIT1), &rt);
	DIALOG_TYPEBOX_HEIGHT = rt.bottom - rt.top;
	pt.x = 0;
	pt.y = rt.top;
	ScreenToClient(hWnd, &pt);
	DIALOG_TYPEBOX_Y = pt.y;
	GetWindowRect(GetDlgItem(hWnd, IDOK), &rt);
	DIALOG_BUTTON_WIDTH = rt.right - rt.left;
	DIALOG_BUTTON_HEIGHT = rt.bottom - rt.top;
	GetWindowRect(GetDlgItem(hWnd, IDC_TAB0), &rt);
	pt.x = 0;
	pt.y = rt.top;
	ScreenToClient(hWnd, &pt);
	DIALOG_TAB_Y = pt.y;

	//GetWindowRect(hWnd, &rt);
	//DIALOG_MIN_WIDTH = (rt.right - rt.left) * 2 / 3;
	//DIALOG_MIN_HEIGHT = DIALOG_MIN_WIDTH * 2 / 3;

	// EBhËʒuini擾BɁATCYy[W_CAOvZB
	int x = GetPrivateProfileInt("EditSprite", "Pos_X", CW_USEDEFAULT, ConfigFileName);
	int y = GetPrivateProfileInt("EditSprite", "Pos_Y", CW_USEDEFAULT, ConfigFileName);
	int w, h;
	{
		// _~[y[W_CAOA^uɂ_~[y[W}ATCYtZB
		EditsprSpritePage dummy_page(project, sprites, this, 0);
		RECT rt;
		GetWindowRect(dummy_page.get_hWnd(), &rt);	// y[W_CAOTCY
		HWND hwTab = GetDlgItem(hWnd, IDC_TAB0);
		TCITEM tci;
		tci.mask = TCIF_TEXT;
		tci.pszText = "dummy";
		TabCtrl_InsertItem(hwTab, 0, &tci);
		TabCtrl_AdjustRect(hwTab, TRUE, &rt);		// ^uRg[TCY
		TabCtrl_DeleteItem(hwTab, 0);
		rt.bottom += DIALOG_TAB_Y;					// _CAÕNCAg̈TCY
		AdjustWindowRect(&rt, (DWORD)GetWindowLong(hWnd, GWL_STYLE), FALSE);	// _CAÕTCY
		w = rt.right - rt.left;
		h = rt.bottom - rt.top;
	}
	if (!(x == CW_USEDEFAULT || y == CW_USEDEFAULT)){
		MoveWindow(hWnd, x, y, w, h, FALSE);
	}else{
		GetWindowRect(hWnd, &rt);
		MoveWindow(hWnd, rt.left, rt.top, w, h, FALSE);
	}

	// GfBbgRg[̏
	SendDlgItemMessage(hWnd, IDC_EDIT0, EM_SETLIMITTEXT, 4, 0);

	return;
}

void EditsprManager::save_config(){
	char s1[32];
	RECT rt;
	GetWindowRect(hWnd, &rt);
	sprintf_s(s1, sizeof s1, "%d", rt.left);
	WritePrivateProfileString("EditSprite", "Pos_X", s1, ConfigFileName);
	sprintf_s(s1, sizeof s1, "%d", rt.top);
	WritePrivateProfileString("EditSprite", "Pos_Y", s1, ConfigFileName);
	return;
}

void EditsprManager::reload(){
	// ey[W[h
	for (PageList::iterator i=pages.begin(), i_end=pages.end(); i!=i_end; i++){
		switch ((*i).type){
			case TabPage::SPRITE_PAGE:
				(*i).sprite_page->reload();
				break;
			case TabPage::DATA_PAGE:
				(*i).data_page->reload();
				break;
		}
	}
}

/*void EditsprManager::sizing(WPARAM wParam, LPARAM lParam){
	RECT &rt = *(RECT*)lParam;
	if (rt.right - rt.left < DIALOG_MIN_WIDTH){
		switch (wParam){
			case WMSZ_LEFT:
			case WMSZ_TOPLEFT:
			case WMSZ_BOTTOMLEFT:
				rt.left = rt.right - DIALOG_MIN_WIDTH;
				break;
			case WMSZ_RIGHT:
			case WMSZ_TOPRIGHT:
			case WMSZ_BOTTOMRIGHT:
				rt.right = rt.left + DIALOG_MIN_WIDTH;
				break;
		}
	}
	if (rt.bottom - rt.top < DIALOG_MIN_HEIGHT){
		switch (wParam){
			case WMSZ_TOP:
			case WMSZ_TOPLEFT:
			case WMSZ_TOPRIGHT:
				rt.top = rt.bottom - DIALOG_MIN_HEIGHT;
				break;
			case WMSZ_BOTTOM:
			case WMSZ_BOTTOMLEFT:
			case WMSZ_BOTTOMRIGHT:
				rt.bottom = rt.top + DIALOG_MIN_HEIGHT;
				break;
		}
	}
	return;
}*/

void EditsprManager::size(int width, int height){
	int DIALOG_BUTTON_X = width - DIALOG_MARGIN_X - DIALOG_BUTTON_WIDTH;
	int DIALOG_TYPESEL_X = DIALOG_BUTTON_X - DIALOG_MARGIN_X - DIALOG_TYPESEL_WIDTH;
	MoveWindow(GetDlgItem(hWnd, IDC_EDIT0),
		DIALOG_MARGIN_X+DIALOG_TEXT_WIDTH, DIALOG_MARGIN_Y,
		DIALOG_TYPESEL_X - (DIALOG_MARGIN_X+DIALOG_TEXT_WIDTH), DIALOG_EDIT_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDC_BUTTON0),
		DIALOG_TYPESEL_X, DIALOG_MARGIN_Y, DIALOG_TYPESEL_WIDTH, DIALOG_EDIT_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDC_EDIT1), DIALOG_MARGIN_X, DIALOG_TYPEBOX_Y,
		DIALOG_BUTTON_X-DIALOG_MARGIN_X*2, DIALOG_TYPEBOX_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDOK), DIALOG_BUTTON_X, DIALOG_MARGIN_Y,
		DIALOG_BUTTON_WIDTH, DIALOG_BUTTON_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDCANCEL),
		DIALOG_BUTTON_X, DIALOG_TYPEBOX_Y+DIALOG_TYPEBOX_HEIGHT-DIALOG_BUTTON_HEIGHT,
		DIALOG_BUTTON_WIDTH, DIALOG_BUTTON_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDC_TAB0), 0, DIALOG_TAB_Y, width, height-DIALOG_TAB_Y, TRUE);
	RECT rt = {0, DIALOG_TAB_Y, width, height};
	TabCtrl_AdjustRect(GetDlgItem(hWnd, IDC_TAB0), FALSE, &rt);
	for (PageList::iterator i=pages.begin(), i_end=pages.end(); i!=i_end; i++){
		switch ((*i).type){
			case TabPage::SPRITE_PAGE:
				(*i).sprite_page->move(rt.left, rt.top, rt.right-rt.left, rt.bottom-rt.top, TRUE);
				break;
			case TabPage::DATA_PAGE:
				(*i).sprite_page->move(rt.left, rt.top, rt.right-rt.left, rt.bottom-rt.top, TRUE);
				break;
		}
	}
	return;
}

void EditsprManager::sprite_sel(){
	char s[16];
	int sprite_num;
	GetDlgItemText(hWnd, IDC_EDIT0, s, sizeof s);
	if (sscanf_s(s, "%x", &sprite_num) < 0){
		sprite_num = -1;
	}
	int r = sprites->sprite_select_dialog(hWnd, sprite_num);
	if (r < 0) return;
	sprintf_s(s, sizeof s, "%04X", r);
	SetDlgItemText(hWnd, IDC_EDIT0, s);
	return;
}

void EditsprManager::type_changed(){
	char s[16];
	int sprite_num;
	GetDlgItemText(hWnd, IDC_EDIT0, s, sizeof s);
	if (sscanf_s(s, "%x", &sprite_num) < 0
		|| sprite_num % 2 || sprite_num < 0 || sprite_num >= sprites->get_sprite_count()*2
		)
	{
		SetDlgItemText(hWnd, IDC_EDIT1, "");
		return;
	}
	SetDlgItemText(hWnd, IDC_EDIT1, sprites->get_sprite_name(sprite_num));
	return;
}

void EditsprManager::open(){
	char s[256];
	int sprite_num;
	GetDlgItemText(hWnd, IDC_EDIT0, s, sizeof s);
	if (sscanf_s(s, "%x", &sprite_num) < 0){
		MessageBox(hWnd, "Please enter the type of sprite", "Edit Sprite", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	if (sprite_num % 2 || sprite_num < 0 || sprite_num >= sprites->get_sprite_count()*2){
		sprintf_s(s, sizeof s, "You can specify the type of sprite is only 0000 %04X hex or even less.",
			sprites->get_sprite_count()*2);
		MessageBox(hWnd, s, "Sprite Editing", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	open_sprite_page(sprite_num);
	return;
}

void EditsprManager::tab_changed(int index){
	int n=0;
	for (PageList::iterator i=pages.begin(), i_end=pages.end(); i!=i_end; i++, n++){
		switch ((*i).type){
			case TabPage::SPRITE_PAGE:
				ShowWindow((*i).sprite_page->get_hWnd(), n==index? SW_SHOW : SW_HIDE);
				break;
			case TabPage::DATA_PAGE:
				ShowWindow((*i).data_page->get_hWnd(), n==index? SW_SHOW : SW_HIDE);
				break;
		}
	}
}


// XvCg|C^ҏWy[WJ
EditsprSpritePage* EditsprManager::open_sprite_page(int sprite_num){
	// ɊJ^uy[Wɂ邩`FbN
	int n=0;
	for (PageList::iterator i=pages.begin(), i_end=pages.end(); i!=i_end; i++, n++){
		if ((*i).type == TabPage::SPRITE_PAGE && (*i).sprite_page->get_sprite_num() == sprite_num){
			TabCtrl_SetCurSel(GetDlgItem(hWnd, IDC_TAB0), n);
			tab_changed(n);
			return (*i).sprite_page;
		}
	}
	// Ȃ΁AVJ
	TabPage page;
	page.type = TabPage::SPRITE_PAGE;
	page.sprite_page = new EditsprSpritePage(project, sprites, this, sprite_num);
	pages.push_back(page);
	// ^uRg[
	HWND hwTab = GetDlgItem(hWnd, IDC_TAB0);
	TCITEM tci;
	tci.mask	= TCIF_TEXT;
	char s[256];
	sprintf_s(s, sizeof s, "Sprite[%04X]", sprite_num);
	tci.pszText	= s;
	TabCtrl_InsertItem(hwTab, n, &tci);
	TabCtrl_SetCurSel(hwTab, n);
	RECT rt;
	GetWindowRect(hwTab, &rt);
	TabCtrl_AdjustRect(hwTab, FALSE, &rt);
	int width = rt.right - rt.left;
	int height = rt.bottom - rt.top;
	ScreenToClient(hWnd, (LPPOINT)&rt);
	page.sprite_page->move(rt.left, rt.top, width, height, FALSE);

	tab_changed(n);
	return page.sprite_page;
}

void EditsprManager::close_sprite_page(EditsprSpritePage *page){
	int n=0;
	for (PageList::iterator i=pages.begin(), i_end=pages.end(); i!=i_end; i++, n++){
		if ((*i).type == TabPage::SPRITE_PAGE && (*i).sprite_page == page){
			TabCtrl_DeleteItem(GetDlgItem(hWnd, IDC_TAB0), n);
			(*i).sprite_page->destroy();
			delete (*i).sprite_page;
			i = pages.erase(i);
			if (i == i_end){
				if (n == 0) return;
				n--;
			}
			TabCtrl_SetCurSel(GetDlgItem(hWnd, IDC_TAB0), n);
			tab_changed(n);
			return;
		}
	}
}



// XvCgf[^ҏWy[WJ
EditsprDataPage* EditsprManager::open_data_page(SADRS adrs){
	// ɊJ^uy[Wɂ邩`FbN
	int n=0;
	for (PageList::iterator i=pages.begin(), i_end=pages.end(); i!=i_end; i++, n++){
		if ((*i).type == TabPage::DATA_PAGE && (*i).data_page->get_adrs() == adrs){
			TabCtrl_SetCurSel(GetDlgItem(hWnd, IDC_TAB0), n);
			tab_changed(n);
			return (*i).data_page;
		}
	}
	// Ȃ΁AVJ
	TabPage page;
	page.type = TabPage::DATA_PAGE;
	page.data_page = new EditsprDataPage(project, sprites, this, adrs);
	pages.push_back(page);
	// ^uRg[
	HWND hwTab = GetDlgItem(hWnd, IDC_TAB0);
	TCITEM tci;
	tci.mask	= TCIF_TEXT;
	char s[256];
	sprintf_s(s, sizeof s, "%04X", adrs);
	tci.pszText	= s;
	TabCtrl_InsertItem(hwTab, n, &tci);
	TabCtrl_SetCurSel(hwTab, n);
	RECT rt;
	GetWindowRect(hwTab, &rt);
	TabCtrl_AdjustRect(hwTab, FALSE, &rt);
	int width = rt.right - rt.left;
	int height = rt.bottom - rt.top;
	ScreenToClient(hWnd, (LPPOINT)&rt);
	page.sprite_page->move(rt.left, rt.top, width, height, FALSE);

	tab_changed(n);
	return page.data_page;
}

void EditsprManager::close_data_page(EditsprDataPage *page){
	int n=0;
	for (PageList::iterator i=pages.begin(), i_end=pages.end(); i!=i_end; i++, n++){
		if ((*i).type == TabPage::DATA_PAGE && (*i).data_page == page){
			TabCtrl_DeleteItem(GetDlgItem(hWnd, IDC_TAB0), n);
			(*i).data_page->destroy();
			delete (*i).data_page;
			i = pages.erase(i);
			if (i == i_end){
				if (n == 0) return;
				n--;
			}
			TabCtrl_SetCurSel(GetDlgItem(hWnd, IDC_TAB0), n);
			tab_changed(n);
			return;
		}
	}
}




