
///////////////////////////////////////////////////////////////////////////////
//
//	sprite_espp.cpp
//

#include <windows.h>
#include <commctrl.h>
#include "sprite_edit.h"
#include "project.h"
#include "id.h"
#include "undo.h"

#ifdef _MSC_VER
#include <uxtheme.h>
#endif

/*
// tHgTCYˑ̒l
static int DIALOG_MARGIN_X=5;
static int DIALOG_TEXT_Y=8;
static int DIALOG_TYPEBOX_X=110;
static int DIALOG_TYPEBOX_H=12;
static int DIALOG_BOTTOMRIGHT_POS_Y=20;
static int DIALOG_BOTTOMRIGHT_POS_X1=80;
static int DIALOG_BOTTOMRIGHT_POS_X2=160;
static int DIALOG_BUTTON_WIDTH=70;
static int DIALOG_BUTTON_HEIGHT=16;
*/


//	XvCgAhXύXUndo Method
//---------------------------------------------------------
class EditsprSpriteAdrs_UndoMethod : public UndoMethod{

	SpritesManager *sprites;
	EditsprManager *editspr;
	WORD sprite_num;
	SADRS adrs_before;
	SADRS adrs_after;

private:
	LPCSTR text_undo() const{ return "Change Sprite Data"; }
	LPCSTR text_redo() const{ return "Change Sprite Data"; }
	void undo(){
		common(adrs_before);
	}
	void redo(){
		common(adrs_after);
	}
	void common(WORD adrs){
		sprites->set_sprite_adrs(sprite_num, adrs);
		editspr->command(IDM_SPRITE_EDITSPR, 0);							// XvCgҏW_CAO\
		EditsprSpritePage *page = editspr->open_sprite_page(sprite_num);	// sprite_num̃y[WJ
		page->update_adrs_edit();
		page->focus_on_adrs_edit();
		return;
	}

public:
	EditsprSpriteAdrs_UndoMethod(SpritesManager *_sprites, EditsprManager *_editspr,
		WORD _sprite_num, SADRS _adrs_before, SADRS _adrs_after)
		: sprites(_sprites), editspr(_editspr),
		sprite_num(_sprite_num), adrs_before(_adrs_before), adrs_after(_adrs_after)
	{}
	~EditsprSpriteAdrs_UndoMethod(){}

};


//=================================================================================================


EditsprSpritePage::EditsprSpritePage(ProjectManager *_project, SpritesManager *_sprites, EditsprManager *_editspr, int _sprite_num)
: project(_project), sprites(_sprites), editspr(_editspr), sprite_num(_sprite_num)
{
	create_dialog(editspr->get_hWnd());
}

EditsprSpritePage::~EditsprSpritePage(){
	destroy();
}


BOOL EditsprSpritePage::Proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	switch (msg){
		case WM_INITDIALOG:
			init();
			return TRUE;
		/*case WM_SIZE:
			size((SHORT)LOWORD(lParam), (SHORT)HIWORD(lParam));
			return TRUE;*/
		//case WM_NEXTDLGCTL:
		//	return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam)){
				case IDC_EDIT0:
					switch (HIWORD(wParam)){
						case EN_CHANGE:
							name_edit_change();
							return TRUE;
						case EN_SETFOCUS:
							SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDC_BUTTON10, 0);
							SetFocus(GetDlgItem(hWnd, IDC_BUTTON10));
							SetFocus(GetDlgItem(hWnd, IDC_EDIT0));
							return TRUE;
					}
					break;
				case IDC_BUTTON10:
					set_name();
					return TRUE;
				case IDC_EDIT1:
					switch (HIWORD(wParam)){
						case EN_CHANGE:
							adrs_edit_change();
							return TRUE;
						case EN_SETFOCUS:
							SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDC_BUTTON11, 0);
							SetFocus(GetDlgItem(hWnd, IDC_BUTTON10));
							SetFocus(GetDlgItem(hWnd, IDC_EDIT1));
							return TRUE;
					}
					break;
				case IDC_BUTTON11:
					set_adrs();
					return TRUE;
				case IDC_BUTTON12:
					open_data();
					return TRUE;
				case IDC_BUTTON13:
					close();
					return TRUE;
			}
			break;
	}
	return FALSE;
}


void EditsprSpritePage::init(){

#ifdef _MSC_VER
	// _CAO̔wi𓧖(^uRg[ɑΉ)
	HMODULE hMod;
	hMod = LoadLibrary("uxtheme.dll");
	if (hMod)
	{
		typedef HRESULT (WINAPI *EnableThemeDialogTexturePROC)(HWND, DWORD);
		EnableThemeDialogTexturePROC pEnableThemeDialogTexture;
		pEnableThemeDialogTexture = (EnableThemeDialogTexturePROC)GetProcAddress(hMod, "EnableThemeDialogTexture");
		if (pEnableThemeDialogTexture)
			pEnableThemeDialogTexture(hWnd, ETDT_ENABLETAB);
		FreeLibrary(hMod);
	}
#endif

	/*
	// v
	RECT rt;
	POINT pt;
	GetWindowRect(GetDlgItem(hWnd, IDC_STATIC0), &rt);
	ScreenToClient(hWnd, (LPPOINT)&rt);
	DIALOG_MARGIN_X = rt.left;
	DIALOG_TEXT_Y   = rt.top;
	GetWindowRect(GetDlgItem(hWnd, IDC_EDITF), &rt);
	DIALOG_TYPEBOX_H = rt.bottom - rt.top;
	ScreenToClient(hWnd, (LPPOINT)&rt);
	DIALOG_TYPEBOX_X = rt.left;
	GetWindowRect(GetDlgItem(hWnd, IDOK), &rt);
	DIALOG_BUTTON_WIDTH  = rt.right - rt.left;
	DIALOG_BUTTON_HEIGHT = rt.bottom - rt.top;
	pt.x = rt.left;
	pt.y = rt.top;
	ScreenToClient(hWnd, &pt);
	GetClientRect(hWnd, &rt);
	DIALOG_BOTTOMRIGHT_POS_Y  = rt.bottom - pt.y;
	DIALOG_BOTTOMRIGHT_POS_X2 = rt.right - pt.x;
	pt.x = rt.right;
	pt.y = rt.bottom;
	GetWindowRect(GetDlgItem(hWnd, IDCANCEL), &rt);
	ScreenToClient(hWnd, (LPPOINT)&rt);
	DIALOG_BOTTOMRIGHT_POS_X1 = pt.x - rt.left;
	*/

	// XvCg
	unable_name_edit_change = true;
	SetDlgItemText(hWnd, IDC_EDIT0, sprites->get_sprite_name(sprite_num));
	unable_name_edit_change = false;

	// AhX
	update_adrs_edit();

	return;
}

void EditsprSpritePage::close(){
	editspr->close_sprite_page(this);
	return;
}


/*
void EditsprSpritePage::size(int width, int height){
	MoveWindow(GetDlgItem(hWnd, IDC_EDITF), DIALOG_TYPEBOX_X, DIALOG_TEXT_Y,
		width - DIALOG_TYPEBOX_X - DIALOG_MARGIN_X, DIALOG_TYPEBOX_H, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDOK), width-DIALOG_BOTTOMRIGHT_POS_X2, height-DIALOG_BOTTOMRIGHT_POS_Y,
		DIALOG_BUTTON_WIDTH, DIALOG_BUTTON_HEIGHT, TRUE);
	MoveWindow(GetDlgItem(hWnd, IDCANCEL), width-DIALOG_BOTTOMRIGHT_POS_X1, height-DIALOG_BOTTOMRIGHT_POS_Y,
		DIALOG_BUTTON_WIDTH, DIALOG_BUTTON_HEIGHT, TRUE);
	return;
}
*/

void EditsprSpritePage::name_edit_change(){
	if (unable_name_edit_change) return;
	RECT rt;
	HWND hwStatic = GetDlgItem(hWnd, IDC_STATIC0);
	HWND hwTab = GetDlgItem(editspr->get_hWnd(), IDC_TAB0);
	SetWindowText(hwStatic, "Name:");
	GetWindowRect(hwStatic, &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(hwStatic, NULL, TRUE);
}

void EditsprSpritePage::set_name(){
	char s[256];
	RECT rt;
	HWND hwStatic = GetDlgItem(hWnd, IDC_STATIC0);
	HWND hwTab = GetDlgItem(editspr->get_hWnd(), IDC_TAB0);
	SetWindowText(hwStatic, "Name:");
	GetWindowRect(hwStatic, &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(hwStatic, NULL, TRUE);
	GetDlgItemText(hWnd, IDC_EDIT0, s, sizeof s);
	sprites->set_sprite_name(sprite_num, s);
	return;
}

void EditsprSpritePage::adrs_edit_change(){
	if (unable_adrs_edit_change) return;
	RECT rt;
	HWND hwStatic = GetDlgItem(hWnd, IDC_STATIC1);
	HWND hwTab = GetDlgItem(editspr->get_hWnd(), IDC_TAB0);
	SetWindowText(hwStatic, "Address:");
	GetWindowRect(hwStatic, &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(hwStatic, NULL, TRUE);
}

void EditsprSpritePage::set_adrs(){
	char s[16];
	int val;
	RECT rt;
	HWND hwStatic = GetDlgItem(hWnd, IDC_STATIC1);
	HWND hwTab = GetDlgItem(editspr->get_hWnd(), IDC_TAB0);
	SetWindowText(hwStatic, "Address):");
	GetWindowRect(hwStatic, &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(hwStatic, NULL, TRUE);
	GetDlgItemText(hWnd, IDC_EDIT1, s, sizeof s);
	if (sscanf_s(s, "%x", &val) < 0){
		MessageBox(hWnd, "Enter the address", "Edit Sprite", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	EditsprSpriteAdrs_UndoMethod *undo = new EditsprSpriteAdrs_UndoMethod(
		sprites, editspr, sprite_num, sprites->get_sprite_adrs(sprite_num), (SADRS)val
		);
	sprites->set_sprite_adrs(sprite_num, (SADRS)val);
	project->undo_buffer.add_method(undo);
	return;
}

void EditsprSpritePage::open_data(){
	char s[16];
	int val;
	GetDlgItemText(hWnd, IDC_EDIT1, s, sizeof s);
	if (sscanf_s(s, "%x", &val) < 0){
		MessageBox(hWnd, "Enter the address", "Edit Sprite", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	editspr->open_data_page((SADRS)val);
	return;
}

void EditsprSpritePage::update_adrs_edit(){
	char s[16];
	unable_adrs_edit_change = true;
	WORD adrs = sprites->get_sprite_adrs(sprite_num);
	sprintf_s(s, sizeof s, "%04X", adrs);
	SetDlgItemText(hWnd, IDC_EDIT1, s);
	SendDlgItemMessage(hWnd, IDC_EDIT1, EM_SETLIMITTEXT, 4, 0);
	unable_adrs_edit_change = false;
}

void EditsprSpritePage::focus_on_adrs_edit(){
	SendMessage(hWnd, DM_SETDEFID, (WPARAM)IDC_BUTTON11, 0);
	SetFocus(GetDlgItem(hWnd, IDC_BUTTON11));
	SetFocus(GetDlgItem(hWnd, IDC_EDIT1));
	return;
}

void EditsprSpritePage::reload(){
	// AhX
	char s[16];
	unable_adrs_edit_change = true;
	WORD adrs = sprites->get_sprite_adrs(sprite_num);
	sprintf_s(s, sizeof s, "%04X", adrs);
	SetDlgItemText(hWnd, IDC_EDIT1, s);
	SendDlgItemMessage(hWnd, IDC_EDIT1, EM_SETLIMITTEXT, 4, 0);
	unable_adrs_edit_change = false;
	RECT rt;
	HWND hwStatic = GetDlgItem(hWnd, IDC_STATIC1);
	HWND hwTab = GetDlgItem(editspr->get_hWnd(), IDC_TAB0);
	SetWindowText(hwStatic, "Address:");
	GetWindowRect(hwStatic, &rt);
	ScreenToClient(hwTab, (LPPOINT)&rt.left);
	ScreenToClient(hwTab, (LPPOINT)&rt.right);
	InvalidateRect(hwTab, &rt, TRUE);
	InvalidateRect(hwStatic, NULL, TRUE);
	return;
}




