
///////////////////////////////////////////////////////////////////////////////
//
//	sprite_select.cpp
//

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "id.h"
#include "sprites.h"


class SpriteSelectDialog : public MyDialog, public RomData_Base{

	SpritesManager *sprites;

private:
	LPCSTR get_template() const{ return "SPRITE_SELECT"; }
	BOOL Proc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
		switch (msg){
			case WM_INITDIALOG:
				init(lParam);
				return TRUE;
			case WM_CTLCOLORSTATIC:
				SetBkMode((HDC)wParam, TRANSPARENT);
				return (BOOL)GetStockObject(NULL_BRUSH);
			case WM_NOTIFY:
				if (((NMHDR*)lParam)->code == TCN_SELCHANGE){
					tab_change();
					return TRUE;
				}
				break;
			case WM_COMMAND:
				switch (LOWORD(wParam)){
					case IDC_LIST0:
					case IDC_LIST2:
						if (HIWORD(wParam) == LBN_DBLCLK){
							SendMessage(hWnd, WM_COMMAND, IDOK, (LPARAM)0);
							return TRUE;
						}
						return FALSE;
					case IDC_LIST1:
						if (HIWORD(wParam) == LBN_SELCHANGE){
							control_change(-1);
						}
						return FALSE;
					case IDOK:
						ok();
						return TRUE;
					case IDCANCEL:
						cancel();
						return TRUE;
				}
				return FALSE;
		}
		return FALSE;
	}
	void init(int init_sprite_num){

		char s[256];

		// ^ȕ
		HWND hwTab = GetDlgItem(hWnd, IDC_TAB0);
		TCITEM tci;
		tci.mask	= TCIF_TEXT;
		tci.pszText	= "Select from list";
		TabCtrl_InsertItem(hwTab, 0, &tci);
		tci.pszText = "Select by type";
		TabCtrl_InsertItem(hwTab, 1, &tci);
		TabCtrl_SetCurSel(hwTab, 0);

		// XvCgꗗ̏
		int sprite_count = sprites->get_sprite_count();
		HWND hwList0 = GetDlgItem(hWnd, IDC_LIST0);
		for (int i=0; i<sprite_count; i++){
			sprintf_s(s, sizeof s, "%04X: %s", i*2, sprites->get_sprite_name(i*2));
			SendMessage(hwList0, LB_INSERTSTRING, (WPARAM)i, (LPARAM)s);
		}
		if (init_sprite_num >= 0){
			SendMessage(hwList0, LB_SETCURSEL, (WPARAM)init_sprite_num/2, (LPARAM)0);
		}

		// R[hȈ
		int control_code_count = sprites->get_control_code_count();
		HWND hwList1 = GetDlgItem(hWnd, IDC_LIST1);
		for (int i=0; i<control_code_count; i++){
			sprintf_s(s, sizeof s, "%04X: %s", i*4, sprites->get_control_code_name(i*4));
			SendMessage(hwList1, LB_INSERTSTRING, (WPARAM)i, (LPARAM)s);
		}
		if (init_sprite_num >= 0){
			SendMessage(hwList1, LB_SETCURSEL, (WPARAM)sprites->get_control_code(init_sprite_num)/4, 0);
			control_change(init_sprite_num);
		}

		load_config();
		return;
	}
	void tab_change(){
		switch (TabCtrl_GetCurSel(GetDlgItem(hWnd, IDC_TAB0))){
			case 0:
				ShowWindow(GetDlgItem(hWnd, IDC_LIST0), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_LIST1), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_LIST2), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_STATIC0), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_STATIC1), SW_HIDE);
				break;
			case 1:
				ShowWindow(GetDlgItem(hWnd, IDC_LIST0), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_LIST1), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_LIST2), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_STATIC0), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_STATIC1), SW_SHOW);
				break;
		}
		return;
	}
	void control_change(int default_sprite_num){
		WORD control_code = (WORD)SendDlgItemMessage(hWnd, IDC_LIST1, LB_GETCURSEL, 0, 0) * 4;
		HWND hwList2 = GetDlgItem(hWnd, IDC_LIST2);
		SendMessage(hwList2, WM_SETREDRAW, FALSE, 0);
		SendMessage(hwList2, LB_RESETCONTENT, 0, 0);
		int sprite_count = sprites->get_sprite_count();
		int c=0;
		int k=-1;
		int dfi = default_sprite_num / 2;
		for (int i=0; i<sprite_count; i++){
			if (sprites->get_control_code(i*2) == control_code){
				char s[256];
				sprintf_s(s, sizeof s, "%04X: %s", i*2, sprites->get_sprite_name(i*2));
				if (i == dfi){
					k = c;
				}
				SendMessage(hwList2, LB_INSERTSTRING, (WPARAM)c++, (LPARAM)s);
			}
		}
		if (k >= 0){
			SendMessage(hwList2, LB_SETCURSEL, (WPARAM)k, 0);
		}
		SendMessage(hwList2, WM_SETREDRAW, TRUE, 0);
	}
	void ok(){
		int sprite_num = -1;
		switch (TabCtrl_GetCurSel(GetDlgItem(hWnd, IDC_TAB0))){
			case 0:
				sprite_num = SendDlgItemMessage(hWnd, IDC_LIST0, LB_GETCURSEL, 0, 0) * 2;
				break;
			case 1:
				{
					char s[256];
					HWND hwList2 = GetDlgItem(hWnd, IDC_LIST2);
					int c = SendMessage(hwList2, LB_GETCURSEL, 0, 0);
					SendMessage(hwList2, LB_GETTEXT, (WPARAM)c, (LPARAM)s);
					s[4] = '\0';
					sscanf_s(s, "%x", &sprite_num);
				}
				break;
		}
		if (sprite_num == -1){
			MessageBox(hWnd, "Please Select a Sprite", "Sprite Selection", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		save_config();
		EndDialog(hWnd, (INT_PTR)sprite_num);
		return;
	}
	void cancel(){
		save_config();
		EndDialog(hWnd, (INT_PTR)-1);
		return;
	}
	void load_config(){
		int tab_page = GetPrivateProfileInt("SpriteSelect", "DefaultTabPage", 0, ConfigFileName);
		if (tab_page<0 || tab_page >= 2){
			tab_page = 0;
		}
		TabCtrl_SetCurSel(GetDlgItem(hWnd, IDC_TAB0), tab_page);
		tab_change();
		return;
	}
	void save_config(){
		int tab_page = TabCtrl_GetCurSel(GetDlgItem(hWnd, IDC_TAB0));
		char s[16];
		sprintf_s(s, sizeof s, "%d", tab_page);
		WritePrivateProfileString("SpriteSelect", "DefaultTabPage", s, ConfigFileName);
		return;
	}
public:
	SpriteSelectDialog(SpritesManager *_sprites) : sprites(_sprites){}
	~SpriteSelectDialog(){}
};



int SpritesManager::sprite_select_dialog(HWND hw_owner, int init_sprite_num){
	SpriteSelectDialog dialog(this);
	return dialog.dialog_box(hw_owner, (LPARAM)init_sprite_num);
}


