
///////////////////////////////////////////////////////////////////////////////
//
//	sprites.h
//

#ifndef _SPRITES_
#define _SPRITES_

///////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "base.h"
#include "window.h"
#include "sprite_find.h"
#include "sprite_edit.h"


class ProjectManager;
class SpritesManager;


//	SpriteDataIterator: XvCgf[^̓ǂݏɗp
//---------------------------------------------------------
class SpriteDataIterator{
private:
	ProjectManager *project;
	BANK bank;
	SADRS adrs;
public:
	SpriteDataIterator(ProjectManager *_proj, BANK _bank, SADRS _adrs);
	SpriteDataIterator(SpritesManager *sprites, SADRS _adrs);
	SpriteDataIterator(const SpriteDataIterator &_src);
	~SpriteDataIterator();
	SADRS get_adrs() const;
	WORD get_command() const;
	WORD get_value() const;
	WORD get_value_of13(int index) const;
	WORD get_value_of4(int index) const;
	void set_command(WORD cmd) const;
	void set_value(WORD val) const;
	void set_value_of13(WORD val, int index) const;
	void set_value_of4(WORD val, int index) const;
	SpriteDataIterator operator ++(int dummy);
	SpriteDataIterator &operator ++();		// ̃R}hɐi
	operator bool();		// ܂I[ɒBĂȂtrueԂ
	bool operator ==(const SpriteDataIterator &itr);
	bool operator !=(const SpriteDataIterator &itr);
};



//	SpritesManager: XvCgf[^Ǘ
//---------------------------------------------------------
class SpritesManager : public RomData_Base{

	// rominfo.ini, sprites.ini瓾f[^уC^[tFCX
private:
	int sprite_count;			// XvCg̐(W2083)
	char (*sprite_name)[256];	// XvCg
	LADRS pSpriteAdrs;			// XvCg`AhX(W0x3BE800)
	BANK pSpriteBank;			// XvCg`f[^̃oN(W0x3F)
	int control_code_count;		// R[h̐(W200)
	char (*control_code_name)[64];	// R[h
public:
	BANK get_sprite_bank();
	int get_sprite_count();
	const char *get_sprite_name(WORD sprite_num);
	int set_sprite_name(WORD sprite_num, const char *name);
	int get_control_code_count();
	const char *get_control_code_name(WORD control_code);

	// ROMɓǂݏf[^уC^[tFCX
private:
	SADRS *sprite_adrs;			// LpSpriteAdrsɂAhX
	WORD *control_code;			// XvCg̐R[h(R}h0000̒lBXvCgIɎgp)
public:
	SADRS get_sprite_adrs(WORD sprite_num);
	void set_sprite_adrs(WORD sprite_num, SADRS sprite_adrs);
	SpriteDataIterator get_sprite(WORD _sprite_adrs);
	WORD get_control_code(WORD sprite_num);
	// wp[֐
	bool get_sprite_graphics(WORD sprite_num, WORD *p_dynamic_num, WORD *p_palette_num, bool *h_flip, bool *v_flip);

private:
	void load_control_code(int sprite_index, SADRS adrs);
	void load_sprite_graphics(SADRS adrs, WORD *p_dynamic_num, WORD *p_palette_num,
		bool *h_flip, bool *v_flip, bool *bDynamicFound, bool *bPaletteFound);



private:
	ProjectManager *project;
	FindsprManager findspr;
	EditsprManager editspr;

public:
	ProjectManager *get_project(){ return project; }

public:
	SpritesManager(ProjectManager *_proj);
	~SpritesManager();

	BOOL create();
	BOOL command(WPARAM wParam, LPARAM lParam);
	BOOL translate_dialog_message(MSG *msg);
	void set_state(BOOL bEnabled);

	
	void load();
	void save();
	int sprite_select_dialog(HWND hw_owner, int init_sprite_num);


};




///////////////////////////////////////////////////////////////////////////////

#endif // _SPRITES_


