
//////////////////////////////////////////////////////////////////////////
//
//	window.h
//

#ifndef _WINDOW_
#define _WINDOW_

//////////////////////////////////////////////////////////////////////////

#include <windows.h>

#ifndef _MSC_VER
#include <stdio.h>
#endif


//	Base
//------------------------------------------------------------------------
class Base{
protected:
	static char ExeDirectory[MAX_PATH];
public:
	static void Init();
};


//	RomData_Base
//------------------------------------------------------------------------
class RomData_Base : public Base{
protected:
	static char RomInfoFileName[MAX_PATH];
	static char SpriteInfoFileName[MAX_PATH];
public:
	static void Init();
};


//	UI_Base
//------------------------------------------------------------------------
class UI_Base : public Base{
protected:
	static HINSTANCE hInst;
	static char ConfigFileName[MAX_PATH];
public:
	static void Init(HINSTANCE _hInst);
};


//	Window
//------------------------------------------------------------------------
class Window : virtual public UI_Base{

protected:

	HWND hWnd;

public:

	Window();
	~Window();

	HWND get_hWnd();

	BOOL create_window_ex(LPCSTR lpszClassName, LPCSTR lpszWindowText, DWORD dwStyle, DWORD dwExStyle,
		LONG x, LONG y, LONG w, LONG h, LPVOID lpParam, Window *pwParent);
	BOOL destroy();
	BOOL move(LONG x, LONG y, LONG w, LONG h, BOOL bRepaint);
	BOOL set_text(LPCSTR lpszText);

};


//	MyWindow
//------------------------------------------------------------------------
class MyWindow : virtual public Window{

protected:

	static BOOL register_class_ex(UINT style, HICON hIcon, HICON hIconSm, HCURSOR hCursor, HBRUSH hbrBackground,
		LPCSTR lpszClassName, LPCSTR lpszMenuName);

private:

	BOOL bValid;	// EBhEĂ邩ǂ

	BOOL Attach(HWND hWnd);
	BOOL Detach();

public:

	MyWindow();
	~MyWindow();

	BOOL create_window_ex(LPCSTR lpszClassName, LPCSTR lpszWindowText, DWORD dwStyle, DWORD dwExStyle,
		LONG x, LONG y, LONG w, LONG h, Window *pwParent);
	static LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	virtual LRESULT Proc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

};





//	Dialog : ʂ̃_CAOEBhE
//------------------------------------------------------------------------
class Dialog : virtual public Window{
protected:

	// _CAOev[g
	virtual LPCSTR get_template() const=0;

public:

	Dialog();
	virtual ~Dialog();

	// [__CAO{bNX
	virtual int dialog_box(Window *pwFrame);
	virtual int dialog_box(Window *pwFrame, LPARAM lParam);

};


//	MyDialog : ̃_CAOEBhE
//------------------------------------------------------------------------
class MyDialog : virtual public Dialog{

protected:

	static BOOL CALLBACK DlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);	// {vV[W
	virtual BOOL Proc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);				// TuvV[W

	BOOL bValid;	// EBhEĂ邩ǂ

private:

	BOOL Attach(HWND hWnd);
	BOOL Detach();

public:

	MyDialog();
	virtual ~MyDialog();

	// [__CAO{bNX
	virtual int dialog_box(Window *pwFrame);
	virtual int dialog_box(Window *pwFrame, LPARAM lParam);
	virtual int dialog_box(HWND hwParent);
	virtual int dialog_box(HWND hwParent, LPARAM lParam);

	// [hX_CAO{bNX
	virtual BOOL create_dialog(Window *pwFrame);
	virtual BOOL create_dialog(Window *pwFrame, LPARAM lParam);
	virtual BOOL create_dialog(HWND hwParent);
	virtual BOOL create_dialog(HWND hwParent, LPARAM lParam);

};


class TabPage : virtual public Window{
public:
	virtual LPCSTR get_text() const=0;
	virtual BOOL create(HWND hwTab)=0;
};



#ifndef _MSC_VER

inline int sprintf_s(char *buf, size_t size, const char *fmt, int a){
    return sprintf(buf, fmt, a);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, int b){
    return sprintf(buf, fmt, a, b);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, const char *b){
    return sprintf(buf, fmt, a, b);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, int b, char *c){
    return sprintf(buf, fmt, a, b, c);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, int b, int c){
    return sprintf(buf, fmt, a, b, c);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, int b, int c, int d){
    return sprintf(buf, fmt, a, b, c, d);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, int b, int c, int d, int e){
    return sprintf(buf, fmt, a, b, c, d, e);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, int b, int c, int d, int e, int f){
    return sprintf(buf, fmt, a, b, c, d, e, f);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, int b, int c, int d, int e, int f, int g){
    return sprintf(buf, fmt, a, b, c, d, e, f, g);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, int b, int c, int d, int e, int f, int g, int h){
    return sprintf(buf, fmt, a, b, c, d, e, f, g, h);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, int a, int b, int c, int d, int e, int f, int g, int h, int i){
    return sprintf(buf, fmt, a, b, c, d, e, f, g, h, i);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, const char *a){
    return sprintf(buf, fmt, a);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, const char *a, const char *b){
    return sprintf(buf, fmt, a, b);
}
inline int sprintf_s(char *buf, size_t size, const char *fmt, const char *a, int b, const char *c){
    return sprintf(buf, fmt, a, b, c);
}

#define sscanf_s sscanf

inline int strcpy_s(char *buf, size_t size, const char *src){
    strcpy(buf, src);
    return 0;
}

inline char *strcat_s(char *buf, size_t size_buf, const char *src){
    return strcat(buf, src);
}

inline void* memcpy_s(void *buf, size_t size_buf, const void *src, size_t size_src){
    return memcpy(buf, src, size_src);
}

inline void* memmove_s(void *buf, size_t size_buf, const void *src, size_t size_src){
    return memmove(buf, src, size_src);
}

inline int max(int a, int b){
    return a>b ? a : b;
}
inline int min(int a, int b){
    return a<b ? a : b;
}

#endif





//////////////////////////////////////////////////////////////////////////

#endif // _WINDOW_








